import argparse
import os.path
from StringIO import StringIO

from org import Org, TodoList

def argparser(subparsers):
    parser_agenda = subparsers.add_parser('todo')
    parser_agenda.add_argument('-f', '--file',
                               dest='filename',
                               type=argparse.FileType('r'),
                               help='Org file to process')
    parser_agenda.set_defaults(func=todo)

def todo(conf, args):
    states = conf['states']
    
    if args.filename is None:
        if 'agenda' in conf and 'files' in conf['agenda']:
            filenames = map(os.path.expanduser, conf['agenda']['files'])
        else:
            filenames = []
    else:
        filenames = [args.filename]
    
    orgs = map(lambda x: Org(x, states), filenames)
    todolist = TodoList(orgs)
    
    for node in todolist:
        print >>args.filename, node.heading(stars = False)

